extends Node2D
class_name ControladorSistema

var _repuestos_actuales = max_repuestos
var _timer
var _segundos_vida
var _root

onready var _label = get_node("Repuestos")
onready var _lbl_instrucciones = get_node("Instrucciones")

export var max_repuestos = 2
export var costo_reparacion := 0

func activar_timer():
	_segundos_vida = _root.segundos_vida_sistema
	_timer = Timer.new()
	add_child(_timer)
	_timer.autostart = true
	_timer.wait_time = _segundos_vida
	_timer.one_shot = true
	_timer.connect("timeout", self, "_timeout")
	print("timer " + name + " activado")
	_timer.start()

func on_click():
	if _root.elementos >= costo_reparacion:
		_root.elementos -= costo_reparacion
		reiniciar_timer()

func reiniciar_timer():
	_timer.wait_time = _segundos_vida
	_timer.start()

func _ready():
	_repuestos_actuales = max_repuestos
	self.visible = false
	_root = get_node("/root") \
		.get_node("PlayGround")
	_label.text=  ""
	_lbl_instrucciones.text = ""

func _process(delta):
	if _timer != null:
		_label.text = str(_timer.time_left)
		_lbl_instrucciones.text = " - " + str(costo_reparacion)
	
func _timeout():
	_root.restar_sistema()
	visible = false
