extends Node
class_name Spawner

# Privates
var _timer_creador
var _timer_maestro
var _is_sistemas_activos := false

onready var _bolitas_escena = preload("res://Assets/Escenas/Bolitas.tscn")
onready var _bolitas_container = get_node("BolitasContainer")
onready var _sistema_central = get_node("SistemaCentral")
onready var _btn_central = get_node("ButtonCentral")
onready var _sistema_ventilacion = get_node("SistemaVentilacion")
onready var _btn_ventilacion = get_node("ButtonVentilacion")
onready var _sistema_transportador = get_node("SistemaTransportador")
onready var _btn_transportador = get_node("ButtonTransportador")
onready var _sistema_sosten = get_node("SistemaSosten")
onready var _btn_sosten = get_node("ButtonSosten")

# Public
var elementos = 0
var sistemas_activos := 0
var es_game_over:= false

#public export
export var segundos_spawn : float = 2.0
export var segundos_incrementar_spawn = 15
export var segundos_vida_sistema := 0
export var max_x_creacion = 1250
export var max_y_creacion = 500

func restar_sistema():
	sistemas_activos -= 1
	
	print("restar sistema: " + str(sistemas_activos))
	
	if sistemas_activos <= 0 :
		print("es game over")
		es_game_over = true
	else:
		_set_timer_creador()

func _ready():
	var primer_bolita = _bolitas_container.get_child(0)
	
	_timer_creador = Timer.new()
	_timer_creador.connect("timeout", self, "_on_timeout_creador")
	_set_timer_creador()

	_timer_maestro = Timer.new()
	add_child(_timer_maestro)
	_timer_maestro.wait_time = segundos_incrementar_spawn
	_timer_maestro.connect("timeout", self, "_on_timeout_master")
	print("start main")
	_timer_maestro.start()

func _on_timeout_creador():
	print("creador")
	
	if !es_game_over :
		_instanciar_bolitas(1)
	else:
		_timer_creador.stop()

func _on_timeout_master():
	print("master")
	if segundos_spawn >= 0.2:
		_set_timer_creador()

func _instanciar_bolitas(num):
	for i in range(num):
		var bolita = _bolitas_escena.instance()
		bolita.position = Vector2( \
			rand_range(1,max_x_creacion), \
			rand_range(1,max_y_creacion))
		_bolitas_container.add_child(bolita)

func _set_timer_creador():
	var multiplicador : float
	var tiempo : float
	
	if _is_sistemas_activos :
		if sistemas_activos == 4:
			multiplicador = 1
		else: if sistemas_activos == 3:
			multiplicador = 2
		else: if sistemas_activos == 2:
			multiplicador = 3
		else: if sistemas_activos == 1:
			multiplicador = 4
	else:
		multiplicador = 0.5
	
	print(">>> Multiplicador: " + str(multiplicador))
	tiempo = segundos_spawn * multiplicador
	print("tiempo: " + str(tiempo))
	
	add_child(_timer_creador)
	_timer_creador.autostart = true
	_timer_creador.wait_time = tiempo
	print("start spawner")
	_timer_creador.start()

func _on_ButtonCentral_pressed():
	if elementos >= _btn_central.costo_activar :
		_btn_central.visible = false
		_sistema_central.visible = true
		sistemas_activos += 1
		elementos -= _btn_central.costo_activar
		_validar_sistemas()

func _on_ButtonTransportador_pressed():
	if elementos >= _btn_transportador.costo_activar :
		_btn_transportador.visible = false
		_sistema_transportador.visible = true
		sistemas_activos += 1
		elementos -= _btn_central.costo_activar
		_validar_sistemas()

func _on_ButtonVentilacion_pressed():
	if elementos >= _btn_ventilacion.costo_activar :
		_btn_ventilacion.visible = false
		_sistema_ventilacion.visible = true
		sistemas_activos += 1
		elementos -= _btn_central.costo_activar
		_validar_sistemas()

func _on_ButtonSosten_pressed():
	if elementos >= _btn_sosten.costo_activar :
		_btn_sosten.visible = false
		_sistema_sosten.visible = true
		sistemas_activos += 1
		elementos -= _btn_central.costo_activar
		_validar_sistemas()

func _validar_sistemas():
	if sistemas_activos == 4:
		_sistema_central.activar_timer()
		_sistema_sosten.activar_timer()
		_sistema_transportador.activar_timer()
		_sistema_ventilacion.activar_timer()
		_is_sistemas_activos = true
